diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc	2025-06-01 20:34:45.641702400 -0700
@@ -10,9 +10,11 @@
 #include "ns3/boolean.h"
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/ctrl-headers.h"
+#include "ns3/demangle.h"
 #include "ns3/double.h"
+#include "ns3/eht-configuration.h"
+#include "ns3/eht-phy.h"
 #include "ns3/he-configuration.h"
-#include "ns3/he-phy.h"
 #include "ns3/he-ppdu.h"
 #include "ns3/interference-helper.h"
 #include "ns3/log.h"
@@ -57,10 +59,11 @@
     DEFAULT_CHANNEL_WIDTH; // expanded to channel width to model spectrum mask
 
 /**
- * HE PHY slightly modified so as to return a given
+ * PHY entity slightly modified so as to return a given
  * STA-ID in case of DL MU for OfdmaSpectrumWifiPhy.
  */
-class OfdmaTestHePhy : public HePhy
+template <typename PhyEntityType>
+class OfdmaTestPhy : public PhyEntityType
 {
   public:
     /**
@@ -68,8 +71,7 @@
      *
      * @param staId the ID of the STA to which this PHY belongs to
      */
-    OfdmaTestHePhy(uint16_t staId);
-    ~OfdmaTestHePhy() override;
+    OfdmaTestPhy(uint16_t staId);
 
     /**
      * Return the STA ID that has been assigned to the station this PHY belongs to.
@@ -87,39 +89,94 @@
      */
     void SetGlobalPpduUid(uint64_t uid);
 
+    /**
+     * Get the band used to transmit the non-OFDMA part of an HE TB PPDU.
+     *
+     * @param txVector the TXVECTOR used for the transmission
+     * @param staId the STA-ID of the station taking part of the UL MU
+     *
+     * @return the spectrum band used to transmit the non-OFDMA part of an HE TB PPDU
+     */
+    WifiSpectrumBandInfo GetNonOfdmaBand(const WifiTxVector& txVector, uint16_t staId) const;
+
   private:
     uint16_t m_staId; ///< ID of the STA to which this PHY belongs to
-};                    // class OfdmaTestHePhy
 
-OfdmaTestHePhy::OfdmaTestHePhy(uint16_t staId)
-    : HePhy(),
-      m_staId(staId)
-{
-}
+    // end of class OfdmaTestPhy
+};
 
-OfdmaTestHePhy::~OfdmaTestHePhy()
+template <typename PhyEntityType>
+OfdmaTestPhy<PhyEntityType>::OfdmaTestPhy(uint16_t staId)
+    : PhyEntityType(),
+      m_staId(staId)
 {
 }
 
+template <typename PhyEntityType>
 uint16_t
-OfdmaTestHePhy::GetStaId(const Ptr<const WifiPpdu> ppdu) const
+OfdmaTestPhy<PhyEntityType>::GetStaId(const Ptr<const WifiPpdu> ppdu) const
 {
+    NS_LOG_FUNCTION(this << ppdu);
     if (ppdu->GetType() == WIFI_PPDU_TYPE_DL_MU)
     {
         return m_staId;
     }
-    return HePhy::GetStaId(ppdu);
+    return PhyEntityType::GetStaId(ppdu);
 }
 
+template <typename PhyEntityType>
 void
-OfdmaTestHePhy::SetGlobalPpduUid(uint64_t uid)
+OfdmaTestPhy<PhyEntityType>::SetGlobalPpduUid(uint64_t uid)
 {
-    m_globalPpduUid = uid;
+    PhyEntityType::m_globalPpduUid = uid;
+}
+
+template <typename PhyEntityType>
+WifiSpectrumBandInfo
+OfdmaTestPhy<PhyEntityType>::GetNonOfdmaBand(const WifiTxVector& txVector, uint16_t staId) const
+{
+    const auto mc = txVector.GetModulationClass();
+    NS_ASSERT(txVector.IsUlMu() && (mc >= WIFI_MOD_CLASS_HE));
+    const auto channelWidth = txVector.GetChannelWidth();
+    NS_ASSERT(channelWidth <= PhyEntityType::m_wifiPhy->GetChannelWidth());
+
+    auto ru = txVector.GetRu(staId);
+    const auto nonOfdmaWidth = PhyEntityType::GetNonOfdmaWidth(ru);
+
+    // Find the RU that encompasses the non-OFDMA part of the HE TB PPDU for the STA-ID
+    auto nonOfdmaRu = WifiRu::FindOverlappingRu(channelWidth, ru, WifiRu::GetRuType(nonOfdmaWidth));
+
+    const auto groupPreamble = WifiRu::GetSubcarrierGroup(
+        channelWidth,
+        WifiRu::GetRuType(nonOfdmaRu),
+        WifiRu::GetPhyIndex(
+            nonOfdmaRu,
+            channelWidth,
+            PhyEntityType::m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})),
+        mc);
+    const auto indices = PhyEntityType::ConvertRuSubcarriers(
+        {channelWidth,
+         PhyEntityType::GetGuardBandwidth(PhyEntityType::m_wifiPhy->GetChannelWidth()),
+         PhyEntityType::m_wifiPhy->GetOperatingChannel().GetFrequencies(),
+         PhyEntityType::m_wifiPhy->GetChannelWidth(),
+         PhyEntityType::m_wifiPhy->GetSubcarrierSpacing(),
+         mc,
+         {groupPreamble.front().first, groupPreamble.back().second},
+         PhyEntityType::m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(channelWidth)});
+    WifiSpectrumBandInfo nonOfdmaBand{};
+    for (const auto& indicesPerSegment : indices)
+    {
+        nonOfdmaBand.indices.emplace_back(indicesPerSegment);
+        nonOfdmaBand.frequencies.emplace_back(
+            PhyEntityType::m_wifiPhy->ConvertIndicesToFrequencies(indicesPerSegment));
+    }
+    return nonOfdmaBand;
 }
 
 /**
  * SpectrumWifiPhy used for testing OFDMA.
  */
+template <typename LatestPhyEntityType>
 class OfdmaSpectrumWifiPhy : public SpectrumWifiPhy
 {
   public:
@@ -134,7 +191,6 @@
      * @param staId the ID of the STA to which this PHY belongs to
      */
     OfdmaSpectrumWifiPhy(uint16_t staId);
-    ~OfdmaSpectrumWifiPhy() override;
 
     void DoInitialize() override;
     void DoDispose() override;
@@ -185,98 +241,113 @@
     Time GetEnergyDuration(Watt_u energy, WifiSpectrumBandInfo band);
 
     /**
-     * @return a const pointer to the HE PHY instance
+     * @return a const pointer to the latest PHY entity instance
      */
-    Ptr<const HePhy> GetHePhy() const;
+    Ptr<LatestPhyEntityType> GetPhyEntity() const;
 
   private:
-    Ptr<OfdmaTestHePhy> m_ofdmTestHePhy; ///< Pointer to HE PHY instance used for OFDMA test
-    TracedCallback<uint64_t>
-        m_phyTxPpduUidTrace; //!< Callback providing UID of the PPDU that is about to be transmitted
-};                           // class OfdmaSpectrumWifiPhy
+    /// Pointer to latest PHY entity instance used for OFDMA test
+    Ptr<OfdmaTestPhy<LatestPhyEntityType>> m_ofdmaTestPhy;
 
+    /// Callback providing UID of the PPDU that is about to be transmitted
+    TracedCallback<uint64_t> m_phyTxPpduUidTrace;
+
+    // end of class OfdmaSpectrumWifiPhy
+};
+
+template <typename LatestPhyEntityType>
 TypeId
-OfdmaSpectrumWifiPhy::GetTypeId()
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::GetTypeId()
 {
     static TypeId tid =
-        TypeId("ns3::OfdmaSpectrumWifiPhy")
+        TypeId(std::string("ns3::OfdmaSpectrumWifiPhy") +
+               Demangle(typeid(LatestPhyEntityType).name()))
             .SetParent<SpectrumWifiPhy>()
             .SetGroupName("Wifi")
             .AddTraceSource("TxPpduUid",
                             "UID of the PPDU to be transmitted",
-                            MakeTraceSourceAccessor(&OfdmaSpectrumWifiPhy::m_phyTxPpduUidTrace),
-                            "ns3::OfdmaSpectrumWifiPhy::TxPpduUidCallback");
+                            MakeTraceSourceAccessor(
+                                &OfdmaSpectrumWifiPhy<LatestPhyEntityType>::m_phyTxPpduUidTrace),
+                            "ns3::OfdmaSpectrumWifiPhy<LatestPhyEntityType>::TxPpduUidCallback");
     return tid;
 }
 
-OfdmaSpectrumWifiPhy::OfdmaSpectrumWifiPhy(uint16_t staId)
+template <typename LatestPhyEntityType>
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::OfdmaSpectrumWifiPhy(uint16_t staId)
     : SpectrumWifiPhy()
 {
-    m_ofdmTestHePhy = Create<OfdmaTestHePhy>(staId);
-    m_ofdmTestHePhy->SetOwner(this);
-}
-
-OfdmaSpectrumWifiPhy::~OfdmaSpectrumWifiPhy()
-{
+    m_ofdmaTestPhy = Create<OfdmaTestPhy<LatestPhyEntityType>>(staId);
+    m_ofdmaTestPhy->SetOwner(this);
 }
 
+template <typename LatestPhyEntityType>
 void
-OfdmaSpectrumWifiPhy::DoInitialize()
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::DoInitialize()
 {
-    // Replace HE PHY instance with test instance
-    m_phyEntities[WIFI_MOD_CLASS_HE] = m_ofdmTestHePhy;
+    const auto modClass = GetModulationClassForStandard(GetStandard());
+    // Replace PHY instance with test instance
+    m_phyEntities[modClass] = m_ofdmaTestPhy;
     SpectrumWifiPhy::DoInitialize();
 }
 
+template <typename LatestPhyEntityType>
 void
-OfdmaSpectrumWifiPhy::DoDispose()
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::DoDispose()
 {
-    m_ofdmTestHePhy = nullptr;
+    m_ofdmaTestPhy = nullptr;
     SpectrumWifiPhy::DoDispose();
 }
 
+template <typename LatestPhyEntityType>
 void
-OfdmaSpectrumWifiPhy::SetPpduUid(uint64_t uid)
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::SetPpduUid(uint64_t uid)
 {
-    m_ofdmTestHePhy->SetGlobalPpduUid(uid);
+    m_ofdmaTestPhy->SetGlobalPpduUid(uid);
     m_previouslyRxPpduUid = uid;
 }
 
+template <typename LatestPhyEntityType>
 void
-OfdmaSpectrumWifiPhy::SetTriggerFrameUid(uint64_t uid)
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::SetTriggerFrameUid(uint64_t uid)
 {
     m_previouslyRxPpduUid = uid;
 }
 
+template <typename LatestPhyEntityType>
 void
-OfdmaSpectrumWifiPhy::StartTx(Ptr<const WifiPpdu> ppdu)
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::StartTx(Ptr<const WifiPpdu> ppdu)
 {
     m_phyTxPpduUidTrace(ppdu->GetUid());
     SpectrumWifiPhy::StartTx(ppdu);
 }
 
+template <typename LatestPhyEntityType>
 std::map<std::pair<uint64_t, WifiPreamble>, Ptr<Event>>&
-OfdmaSpectrumWifiPhy::GetCurrentPreambleEvents()
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::GetCurrentPreambleEvents()
 {
     return m_currentPreambleEvents;
 }
 
+template <typename LatestPhyEntityType>
 Ptr<Event>
-OfdmaSpectrumWifiPhy::GetCurrentEvent()
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::GetCurrentEvent()
 {
     return m_currentEvent;
 }
 
+template <typename LatestPhyEntityType>
 Time
-OfdmaSpectrumWifiPhy::GetEnergyDuration(Watt_u energy, WifiSpectrumBandInfo band)
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::GetEnergyDuration(Watt_u energy,
+                                                             WifiSpectrumBandInfo band)
 {
     return m_interference->GetEnergyDuration(energy, band);
 }
 
-Ptr<const HePhy>
-OfdmaSpectrumWifiPhy::GetHePhy() const
+template <typename LatestPhyEntityType>
+Ptr<LatestPhyEntityType>
+OfdmaSpectrumWifiPhy<LatestPhyEntityType>::GetPhyEntity() const
 {
-    return DynamicCast<const HePhy>(GetLatestPhyEntity());
+    return DynamicCast<LatestPhyEntityType>(m_ofdmaTestPhy /*GetLatestPhyEntity()*/);
 }
 
 /**
@@ -285,11 +356,14 @@
  *
  * @brief DL-OFDMA PHY test
  */
+template <typename LatestPhyEntityType>
 class TestDlOfdmaPhyTransmission : public TestCase
 {
   public:
+    /**
+     * Constructor
+     */
     TestDlOfdmaPhyTransmission();
-    ~TestDlOfdmaPhyTransmission() override;
 
   private:
     void DoSetup() override;
@@ -407,54 +481,55 @@
      * @param phy the PHY
      * @param expectedState the expected state of the PHY
      */
-    void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
+    void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+                       WifiPhyState expectedState);
     /**
      * Check the PHY state now
      * @param phy the PHY
      * @param expectedState the expected state of the PHY
      */
-    void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
+    void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+                         WifiPhyState expectedState);
 
-    uint32_t m_countRxSuccessSta1; ///< count RX success for STA 1
-    uint32_t m_countRxSuccessSta2; ///< count RX success for STA 2
-    uint32_t m_countRxSuccessSta3; ///< count RX success for STA 3
-    uint32_t m_countRxFailureSta1; ///< count RX failure for STA 1
-    uint32_t m_countRxFailureSta2; ///< count RX failure for STA 2
-    uint32_t m_countRxFailureSta3; ///< count RX failure for STA 3
-    uint32_t m_countRxBytesSta1;   ///< count RX bytes for STA 1
-    uint32_t m_countRxBytesSta2;   ///< count RX bytes for STA 2
-    uint32_t m_countRxBytesSta3;   ///< count RX bytes for STA 3
-
-    Ptr<SpectrumWifiPhy> m_phyAp;           ///< PHY of AP
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta1;    ///< PHY of STA 1
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta2;    ///< PHY of STA 2
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta3;    ///< PHY of STA 3
-    Ptr<WaveformGenerator> m_phyInterferer; ///< PHY of interferer
+    WifiModulationClass m_modClass; ///< the modulation class to consider for the test
 
-    MHz_u m_frequency;           ///< frequency
-    MHz_u m_channelWidth;        ///< channel width
-    Time m_expectedPpduDuration; ///< expected duration to send MU PPDU
+    uint32_t m_countRxSuccessSta1{0}; ///< count RX success for STA 1
+    uint32_t m_countRxSuccessSta2{0}; ///< count RX success for STA 2
+    uint32_t m_countRxSuccessSta3{0}; ///< count RX success for STA 3
+    uint32_t m_countRxFailureSta1{0}; ///< count RX failure for STA 1
+    uint32_t m_countRxFailureSta2{0}; ///< count RX failure for STA 2
+    uint32_t m_countRxFailureSta3{0}; ///< count RX failure for STA 3
+    uint32_t m_countRxBytesSta1{0};   ///< count RX bytes for STA 1
+    uint32_t m_countRxBytesSta2{0};   ///< count RX bytes for STA 2
+    uint32_t m_countRxBytesSta3{0};   ///< count RX bytes for STA 3
+
+    Ptr<SpectrumWifiPhy> m_phyAp;                             ///< PHY of AP
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> m_phySta1; ///< PHY of STA 1
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> m_phySta2; ///< PHY of STA 2
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> m_phySta3; ///< PHY of STA 3
+    Ptr<WaveformGenerator> m_phyInterferer;                   ///< PHY of interferer
+
+    MHz_u m_frequency{DEFAULT_FREQUENCY};        ///< frequency
+    MHz_u m_channelWidth{DEFAULT_CHANNEL_WIDTH}; ///< channel width
+    Time m_expectedPpduDuration;                 ///< expected duration to send MU PPDU
 };
 
-TestDlOfdmaPhyTransmission::TestDlOfdmaPhyTransmission()
-    : TestCase("DL-OFDMA PHY test"),
-      m_countRxSuccessSta1(0),
-      m_countRxSuccessSta2(0),
-      m_countRxSuccessSta3(0),
-      m_countRxFailureSta1(0),
-      m_countRxFailureSta2(0),
-      m_countRxFailureSta3(0),
-      m_countRxBytesSta1(0),
-      m_countRxBytesSta2(0),
-      m_countRxBytesSta3(0),
-      m_frequency(DEFAULT_FREQUENCY),
-      m_channelWidth(DEFAULT_CHANNEL_WIDTH),
-      m_expectedPpduDuration(NanoSeconds(306400))
+template <typename LatestPhyEntityType>
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::TestDlOfdmaPhyTransmission()
+    : TestCase{std::string("DL-OFDMA PHY test for ") +
+               ((Demangle(typeid(LatestPhyEntityType).name()).find("He") != std::string::npos)
+                    ? "HE"
+                    : "EHT")},
+      m_modClass{(Demangle(typeid(LatestPhyEntityType).name()).find("He") != std::string::npos)
+                     ? WIFI_MOD_CLASS_HE
+                     : WIFI_MOD_CLASS_EHT},
+      m_expectedPpduDuration{NanoSeconds(306400)}
 {
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::ResetResults()
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::ResetResults()
 {
     m_countRxSuccessSta1 = 0;
     m_countRxSuccessSta2 = 0;
@@ -467,57 +542,92 @@
     m_countRxBytesSta3 = 0;
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::SendMuPpdu(uint16_t rxStaId1, uint16_t rxStaId2)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::SendMuPpdu(uint16_t rxStaId1, uint16_t rxStaId2)
 {
     NS_LOG_FUNCTION(this << rxStaId1 << rxStaId2);
     WifiConstPsduMap psdus;
-    WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
-                          WIFI_PREAMBLE_HE_MU,
-                          NanoSeconds(800),
-                          1,
-                          1,
-                          0,
-                          m_channelWidth,
-                          false,
-                          false};
-    HeRu::RuType ruType = HeRu::RU_106_TONE;
+    WifiTxVector txVector{
+        (m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
+        0,
+        (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_PREAMBLE_HE_MU : WIFI_PREAMBLE_EHT_MU,
+        NanoSeconds(800),
+        1,
+        1,
+        0,
+        m_channelWidth,
+        false,
+        false};
+    if (m_modClass == WIFI_MOD_CLASS_EHT)
+    {
+        txVector.SetEhtPpduType(0);
+    }
+    auto ruType{RuType::RU_TYPE_MAX};
     if (m_channelWidth == MHz_u{20})
     {
-        ruType = HeRu::RU_106_TONE;
-        txVector.SetRuAllocation({96}, 0);
+        ruType = RuType::RU_106_TONE;
+        const uint16_t ruAllocPer20 = (m_modClass == WIFI_MOD_CLASS_HE) ? 96 : 48;
+        txVector.SetRuAllocation({ruAllocPer20}, 0);
     }
     else if (m_channelWidth == MHz_u{40})
     {
-        ruType = HeRu::RU_242_TONE;
-        txVector.SetRuAllocation({192, 192}, 0);
+        ruType = RuType::RU_242_TONE;
+        const uint16_t ruAllocPer20 = (m_modClass == WIFI_MOD_CLASS_HE) ? 192 : 64;
+        txVector.SetRuAllocation({ruAllocPer20, ruAllocPer20}, 0);
     }
     else if (m_channelWidth == MHz_u{80})
     {
-        ruType = HeRu::RU_484_TONE;
-        txVector.SetRuAllocation({200, 200, 200, 200}, 0);
+        ruType = RuType::RU_484_TONE;
+        const uint16_t ruAllocUser = (m_modClass == WIFI_MOD_CLASS_HE) ? 200 : 72;
+        const uint16_t ruAllocNoUser = (m_modClass == WIFI_MOD_CLASS_HE) ? 114 : 29;
+        txVector.SetRuAllocation({ruAllocUser, ruAllocNoUser, ruAllocNoUser, ruAllocUser}, 0);
     }
     else if (m_channelWidth == MHz_u{160})
     {
-        ruType = HeRu::RU_996_TONE;
-        txVector.SetRuAllocation({208, 208, 208, 208, 208, 208, 208, 208}, 0);
+        ruType = RuType::RU_996_TONE;
+        const uint16_t ruAllocUser = (m_modClass == WIFI_MOD_CLASS_HE) ? 208 : 80;
+        const uint16_t ruAllocNoUser = (m_modClass == WIFI_MOD_CLASS_HE) ? 115 : 30;
+        txVector.SetRuAllocation({ruAllocUser,
+                                  ruAllocNoUser,
+                                  ruAllocUser,
+                                  ruAllocNoUser,
+                                  ruAllocNoUser,
+                                  ruAllocUser,
+                                  ruAllocNoUser,
+                                  ruAllocUser},
+                                 0);
+    }
+    else if (m_channelWidth == MHz_u{320})
+    {
+        NS_ASSERT(m_modClass >= WIFI_MOD_CLASS_EHT);
+        ruType = RuType::RU_2x996_TONE;
+        txVector.SetRuAllocation({88, 30, 88, 30, 88, 30, 88, 30, 30, 88, 30, 88, 30, 88, 30, 88},
+                                 0);
     }
     else
     {
-        NS_ASSERT_MSG(false, "Unsupported channel width");
+        NS_ASSERT_MSG(false, "Unsupported channel width: " << m_channelWidth);
     }
 
     txVector.SetSigBMode(VhtPhy::GetVhtMcs5());
 
-    HeRu::RuSpec ru1(ruType, 1, true);
+    const auto ru1 = (m_modClass == WIFI_MOD_CLASS_HE)
+                         ? WifiRu::RuSpec(HeRu::RuSpec{ruType, 1, true})
+                         : WifiRu::RuSpec(EhtRu::RuSpec{ruType, 1, true, true});
     txVector.SetRu(ru1, rxStaId1);
-    txVector.SetMode(HePhy::GetHeMcs7(), rxStaId1);
+    txVector.SetMode((m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
+                     rxStaId1);
     txVector.SetNss(1, rxStaId1);
 
-    HeRu::RuSpec ru2(ruType, (m_channelWidth == MHz_u{160} ? 1 : 2), m_channelWidth != MHz_u{160});
+    std::size_t ru2Index = (m_channelWidth > MHz_u{80}) ? 1 : 2;
+    const auto ru2 =
+        (m_modClass == WIFI_MOD_CLASS_HE)
+            ? WifiRu::RuSpec(HeRu::RuSpec{ruType, ru2Index, m_channelWidth != MHz_u{160}})
+            : WifiRu::RuSpec(EhtRu::RuSpec{ruType, ru2Index, m_channelWidth != MHz_u{320}, true});
     txVector.SetRu(ru2, rxStaId2);
-    txVector.SetMode(HePhy::GetHeMcs9(), rxStaId2);
+    txVector.SetMode((m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs9() : EhtPhy::GetEhtMcs9(),
+                     rxStaId2);
     txVector.SetNss(1, rxStaId2);
 
     Ptr<Packet> pkt1 = Create<Packet>(1000);
@@ -541,138 +651,160 @@
     m_phyAp->Send(psdus, txVector);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::GenerateInterference(Ptr<SpectrumValue> interferencePsd, Time duration)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::GenerateInterference(
+    Ptr<SpectrumValue> interferencePsd,
+    Time duration)
 {
     m_phyInterferer->SetTxPowerSpectralDensity(interferencePsd);
     m_phyInterferer->SetPeriod(duration);
     m_phyInterferer->Start();
-    Simulator::Schedule(duration, &TestDlOfdmaPhyTransmission::StopInterference, this);
+    Simulator::Schedule(duration,
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::StopInterference,
+                        this);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::StopInterference()
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::StopInterference()
 {
     m_phyInterferer->Stop();
 }
 
-TestDlOfdmaPhyTransmission::~TestDlOfdmaPhyTransmission()
-{
-}
-
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::RxSuccessSta1(Ptr<const WifiPsdu> psdu,
-                                          RxSignalInfo rxSignalInfo,
-                                          const WifiTxVector& txVector,
-                                          const std::vector<bool>& /*statusPerMpdu*/)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::RxSuccessSta1(
+    Ptr<const WifiPsdu> psdu,
+    RxSignalInfo rxSignalInfo,
+    const WifiTxVector& txVector,
+    const std::vector<bool>& /*statusPerMpdu*/)
 {
     NS_LOG_FUNCTION(this << *psdu << rxSignalInfo << txVector);
     m_countRxSuccessSta1++;
     m_countRxBytesSta1 += (psdu->GetSize() - 30);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::RxSuccessSta2(Ptr<const WifiPsdu> psdu,
-                                          RxSignalInfo rxSignalInfo,
-                                          const WifiTxVector& txVector,
-                                          const std::vector<bool>& /*statusPerMpdu*/)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::RxSuccessSta2(
+    Ptr<const WifiPsdu> psdu,
+    RxSignalInfo rxSignalInfo,
+    const WifiTxVector& txVector,
+    const std::vector<bool>& /*statusPerMpdu*/)
 {
     NS_LOG_FUNCTION(this << *psdu << rxSignalInfo << txVector);
     m_countRxSuccessSta2++;
     m_countRxBytesSta2 += (psdu->GetSize() - 30);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::RxSuccessSta3(Ptr<const WifiPsdu> psdu,
-                                          RxSignalInfo rxSignalInfo,
-                                          const WifiTxVector& txVector,
-                                          const std::vector<bool>& /*statusPerMpdu*/)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::RxSuccessSta3(
+    Ptr<const WifiPsdu> psdu,
+    RxSignalInfo rxSignalInfo,
+    const WifiTxVector& txVector,
+    const std::vector<bool>& /*statusPerMpdu*/)
 {
     NS_LOG_FUNCTION(this << *psdu << rxSignalInfo << txVector);
     m_countRxSuccessSta3++;
     m_countRxBytesSta3 += (psdu->GetSize() - 30);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::RxFailureSta1(Ptr<const WifiPsdu> psdu)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::RxFailureSta1(Ptr<const WifiPsdu> psdu)
 {
     NS_LOG_FUNCTION(this << *psdu);
     m_countRxFailureSta1++;
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::RxFailureSta2(Ptr<const WifiPsdu> psdu)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::RxFailureSta2(Ptr<const WifiPsdu> psdu)
 {
     NS_LOG_FUNCTION(this << *psdu);
     m_countRxFailureSta2++;
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::RxFailureSta3(Ptr<const WifiPsdu> psdu)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::RxFailureSta3(Ptr<const WifiPsdu> psdu)
 {
     NS_LOG_FUNCTION(this << *psdu);
     m_countRxFailureSta3++;
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::CheckResultsSta1(uint32_t expectedRxSuccess,
-                                             uint32_t expectedRxFailure,
-                                             uint32_t expectedRxBytes)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckResultsSta1(uint32_t expectedRxSuccess,
+                                                                  uint32_t expectedRxFailure,
+                                                                  uint32_t expectedRxBytes)
 {
     NS_TEST_ASSERT_MSG_EQ(m_countRxSuccessSta1,
                           expectedRxSuccess,
                           "The number of successfully received packets by STA 1 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxFailureSta1,
                           expectedRxFailure,
-                          "The number of unsuccessfuly received packets by STA 1 is not correct!");
+                          "The number of unsuccessfully received packets by STA 1 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesSta1,
                           expectedRxBytes,
                           "The number of bytes received by STA 1 is not correct!");
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::CheckResultsSta2(uint32_t expectedRxSuccess,
-                                             uint32_t expectedRxFailure,
-                                             uint32_t expectedRxBytes)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckResultsSta2(uint32_t expectedRxSuccess,
+                                                                  uint32_t expectedRxFailure,
+                                                                  uint32_t expectedRxBytes)
 {
     NS_TEST_ASSERT_MSG_EQ(m_countRxSuccessSta2,
                           expectedRxSuccess,
                           "The number of successfully received packets by STA 2 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxFailureSta2,
                           expectedRxFailure,
-                          "The number of unsuccessfuly received packets by STA 2 is not correct!");
+                          "The number of unsuccessfully received packets by STA 2 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesSta2,
                           expectedRxBytes,
                           "The number of bytes received by STA 2 is not correct!");
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::CheckResultsSta3(uint32_t expectedRxSuccess,
-                                             uint32_t expectedRxFailure,
-                                             uint32_t expectedRxBytes)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckResultsSta3(uint32_t expectedRxSuccess,
+                                                                  uint32_t expectedRxFailure,
+                                                                  uint32_t expectedRxBytes)
 {
     NS_TEST_ASSERT_MSG_EQ(m_countRxSuccessSta3,
                           expectedRxSuccess,
                           "The number of successfully received packets by STA 3 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxFailureSta3,
                           expectedRxFailure,
-                          "The number of unsuccessfuly received packets by STA 3 is not correct!");
+                          "The number of unsuccessfully received packets by STA 3 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesSta3,
                           expectedRxBytes,
                           "The number of bytes received by STA 3 is not correct!");
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState(
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+    WifiPhyState expectedState)
 {
     // This is needed to make sure PHY state will be checked as the last event if a state change
     // occurred at the exact same time as the check
-    Simulator::ScheduleNow(&TestDlOfdmaPhyTransmission::DoCheckPhyState, this, phy, expectedState);
+    Simulator::ScheduleNow(&TestDlOfdmaPhyTransmission<LatestPhyEntityType>::DoCheckPhyState,
+                           this,
+                           phy,
+                           expectedState);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy,
-                                            WifiPhyState expectedState)
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::DoCheckPhyState(
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+    WifiPhyState expectedState)
 {
     WifiPhyState currentState;
     PointerValue ptr;
@@ -686,9 +818,13 @@
                                        << expectedState << " at " << Simulator::Now());
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::DoSetup()
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::DoSetup()
 {
+    const auto standard =
+        (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_STANDARD_80211ax : WIFI_STANDARD_80211be;
+
     Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
     Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel>();
     lossModel->SetFrequency(MHzToHz(m_frequency));
